// Verilog model  - Wed Jul 28 10:46:46 2004

`timescale 1ns / 1ps

module ext_fifo_intrf(CLK, DATA_IN, FF_IN_RDY_B,
      FF_PAF_B, FF_HF_B, FF_PAE_B, FF_OUT_RDY_B,
      FROM_FIFO, WFUNCT, RFUNCT, READ, ECC_ENA, OE, POW_ON_RST, FF_RST,
      VALDAT, INJ_ERRS, TEST_MODE, SW2,
      DATA_OUT, FF_MARK, FF_MRS_B, FF_PRS_B, FF_TRESET,
      FF_OE_B, FF_RCLK, FF_RCS_B, FF_REN_B, FF_RT_B, FF_SCLK,
      FF_SEN_B, FF_FWFT_SI, FF_WCLK, FF_WCS_B, FF_WEN_B, FF_LD_B,
      FUNCT_DONE, WHOLD, RHOLD, OUT_DAT_VALID, OUT_RDY, FLSHD,
      RD_ERR, MT_ERR, RT_ERR, MK_ERR, TO_FIFO, WRT_ERR,
      TEST_A, TEST_B, TEST_C);

    input CLK;
    input [15:0] DATA_IN;
    input FF_IN_RDY_B;
    input FF_PAF_B;
    input FF_HF_B;
    input FF_PAE_B;
    input FF_OUT_RDY_B;
    input [35:0] FROM_FIFO;
    input [2:0] WFUNCT;
    input [2:0] RFUNCT;
    input READ;
    input ECC_ENA;
    input OE;
    input POW_ON_RST;
    input FF_RST;
    input VALDAT;
    input INJ_ERRS;
    input TEST_MODE;
    input [3:0] SW2;
   output [15:0] DATA_OUT;
   output FF_MARK;
   output FF_MRS_B;
   output FF_PRS_B;
   output FF_TRESET;
   output FF_OE_B;
   output FF_RCLK;
   output FF_RCS_B;
   output FF_REN_B;
   output FF_RT_B;
   output FF_SCLK;
   output FF_SEN_B;
   output FF_FWFT_SI;
   output FF_WCLK;
   output FF_WCS_B;
   output FF_WEN_B;
   output FF_LD_B;
   output FUNCT_DONE;
   output WHOLD;
   output RHOLD;
   output OUT_DAT_VALID;
   output OUT_RDY;
   output FLSHD;
   output RD_ERR;
   output MT_ERR;
   output RT_ERR;
   output MK_ERR;
   output [35:0] TO_FIFO;
   output WRT_ERR;
   output [15:0] TEST_A;
   output [15:0] TEST_B;
   output [15:0] TEST_C;
//   output [35:0] OFFSET;

reg [15:0] TEST_A;
reg [15:0] TEST_B;
reg [15:0] TEST_C;

reg FF_WEN_B;
reg FF_REN_B;
reg FF_MARK;
reg FF_RT_B;

reg WEN;
reg WEN1;
reg REN;
reg DRP;
reg MARK;
reg RT;
reg RSM;
reg STM;


reg [4:0] EXFF_WR_ST;
reg [4:0] EXFF_RD_ST;
reg PRGDONE;
reg RBKDONE;
reg MRSTDONE;
reg PRSTDONE;
reg WHOLD;
reg RHOLD;
reg [35:0] OFFSET;
reg SDV;
reg RDE1,RDE2,RDE3,RDE4,RDE5,RDE6;
reg ODV1,ODV2,ODV3,ODV4,ODV5,ODV6,ODV7;
reg FDV1,FDV2,FDV3,FDV4,FDV5,FDV6,FDV7;
reg OUT_DAT_VALID;
reg DCD_DAT_VALID;
reg DRP_DAT_VALID;
reg ENATMR;
reg [11:0] RD_TMR;
reg RD_ERR;
reg RT_ERR;
reg MT_ERR;
reg MK_ERR;
reg WRT_ERR;
reg MRST,MRST1,MRST2,MRST3;
reg PRST,PRST1,PRST2,PRST3;
reg TRESET;
reg FWFT;
reg PU_RSM;
reg L1_TO,L1_FR;
reg L2,L3,L4;
reg CLRL_TO,CLRL_FR;
reg WLOAD;
reg RLOAD;
reg LOAD1;
reg LOAD2;
reg RDOFF;
reg UPDTOFF1;
reg UPDTOFF2;
reg CAP_OFF1;
reg CAP_OFF2;
reg SEL_BOD;
reg LOAD_BOD;

reg [15:0] DATA_IN1;
reg [15:0] DATA_IN2;
reg [15:0] DAT_BOD;
reg [15:0] DATA_OUT;
reg [35:0] FROM_FIFO1;
reg [35:0] TO_FIFO;

wire IN_RDY,FF_OUT_RDY,PAE,PAF,HF;
wire RD_TMOUT;
wire CLRL;
wire FUNCT_DONE;

reg OUT_RDY;
reg ORH0,ORH1,ORH2,ORH3,ORH4,ORH5,ORH6;
reg INT_OUT_RDY;

reg [3:0] FF_MJ_DCD;
reg [3:0] FFH1;
reg [3:0] FFH2;
reg [3:0] FFH3;
reg [3:0] FFH4;
reg [3:0] FFH5;
reg [3:0] FFH6;
wire [11:0] ECC_PARITY;
wire [11:0] DCD_DATA;
wire [11:0] DCD_PARITY;
wire GOOD_WORD;
wire BAD_TX;

reg BEG_O_DATA;
reg MTCH2_OUT_OF_3;
reg NE3_OUT_OF_3;
reg MTCH1,MTCH2,MTCH3,MTCH4,MTCH5,MTCH6;
reg NE1,NE2,NE3,NE4,NE5,NE6;
reg FLSHD;

reg [31:0] UN_COR_ERR_REG;
reg [31:0] COR_ERR_REG;
reg RST_ERR_CNT;
wire ERR_CNT_RST;
reg  ERCNT;
reg  [9:0] INJ_CNT;
wire INJ_ERRS;
wire INJ_TYP1_NOW;
wire INJ_TYP2_NOW;

wire FF_TRESET;
wire FF_LD_B;

wire FF_WCS_B;
wire FF_RCS_B;
wire FF_OE_B;

`ifdef HEADER
`else
`include "header.v"
`endif

assign FF_WCS_B = 0;
assign FF_RCS_B = 0;
assign FF_OE_B  = 0;

   
assign FF_MRS_B = !MRST;
assign FF_PRS_B = !PRST;
assign FF_TRESET = TRESET;
assign FF_FWFT_SI = FWFT;
assign FF_LD_B =  !FWFT && !WLOAD && !RLOAD;

assign     IN_RDY = !FF_IN_RDY_B;
assign FF_OUT_RDY = !FF_OUT_RDY_B;
assign        PAE = !FF_PAE_B;
assign        PAF = !FF_PAF_B;
assign         HF = !FF_HF_B;
   
assign FF_SEN_B = 1;
assign RD_TMOUT = (RD_TMR == `Ex_FF_Rd_TmOut);

assign ERR_CNT_RST = RST_ERR_CNT || POW_ON_RST;

assign CLRL = CLRL_TO || CLRL_FR;
assign FUNCT_DONE = PRGDONE || RBKDONE || MRSTDONE || PRSTDONE;

assign INJ_TYP1_NOW = INJ_ERRS && ((INJ_CNT%128) == 10'h07F);
assign INJ_TYP2_NOW = INJ_ERRS && (INJ_CNT == 10'h3FF);

always @(posedge CLK)
begin
   case (SW2)
      4'hA:
         begin
            TEST_A <= TO_FIFO[15:0];
            TEST_B <= TO_FIFO[31:16];
            TEST_C[3:0] <= TO_FIFO[35:32];
            TEST_C[4] <= FF_WEN_B;
            TEST_C[5] <= WRT_ERR;
            TEST_C[6] <= FF_REN_B;
            TEST_C[7] <= RD_ERR;
            TEST_C[10:8] <= WFUNCT[2:0];
            TEST_C[11] <= FF_IN_RDY_B;
            TEST_C[14:12] <= RFUNCT[2:0];
            TEST_C[15] <= FF_OUT_RDY_B;
         end
      4'hB:
         begin
            TEST_A <= FROM_FIFO[15:0];
            TEST_B <= FROM_FIFO[31:16];
            TEST_C[3:0] <= FROM_FIFO[35:32];
            TEST_C[4] <= FF_WEN_B;
            TEST_C[5] <= WRT_ERR;
            TEST_C[6] <= FF_REN_B;
            TEST_C[7] <= RD_ERR;
            TEST_C[10:8] <= WFUNCT[2:0];
            TEST_C[11] <= FF_IN_RDY_B;
            TEST_C[14:12] <= RFUNCT[2:0];
            TEST_C[15] <= FF_OUT_RDY_B;
         end
      4'hC, 4'hD:
         begin
            TEST_A <= DATA_OUT;
            TEST_B[4:0] <= EXFF_RD_ST;
            TEST_B[5] <= ECC_ENA;
            TEST_B[6] <= TEST_MODE;
            TEST_B[7] <= INJ_ERRS;
            TEST_B[10:8] <= 3'h0; // V_RFUNCT[2:0]
            TEST_B[11] <= 1'b0;   // V_FF_READ
            TEST_B[14:12] <= RFUNCT[2:0];
            TEST_B[15] <= READ;
            TEST_C[0] <= REN;
            TEST_C[1] <= DRP;
            TEST_C[2] <= RHOLD;
            TEST_C[3] <= RD_ERR;
            TEST_C[4] <= OE;
            TEST_C[5] <= FF_OUT_RDY;
            TEST_C[6] <= INT_OUT_RDY;
            TEST_C[7] <= OUT_RDY;
            TEST_C[8] <= OUT_DAT_VALID;
            TEST_C[9] <= FLSHD;
            TEST_C[10] <= BEG_O_DATA;
            TEST_C[11] <= NE3_OUT_OF_3;
            TEST_C[12] <= MTCH2_OUT_OF_3;
            TEST_C[13] <= NE6;
            TEST_C[14] <= MTCH6;
            TEST_C[15] <= FUNCT_DONE;
         end
      default: 
         begin
            TEST_A <= 16'h0000;
            TEST_B <= 16'h0000;
            TEST_C <= 16'h0000;
         end
   endcase
end

always @(posedge CLK or posedge POW_ON_RST)
begin
   if(POW_ON_RST)
      INJ_CNT <= 10'h000;
   else
      if(WEN)
         INJ_CNT <= INJ_CNT + 1;
      else
         INJ_CNT <= INJ_CNT;
end

// Input registers

always @(posedge CLK)
begin
   DATA_IN1 <= DATA_IN;
   if(INJ_TYP2_NOW && !SEL_BOD)
      DATA_IN2 <= DAT_BOD^16'h01C8;
   else if(INJ_TYP1_NOW && !SEL_BOD)
      DATA_IN2 <= DAT_BOD^16'h0402;
   else
      DATA_IN2 <= DAT_BOD;
   FROM_FIFO1 <= FROM_FIFO;
   FFH1 <= FF_MJ_DCD;
   FFH2 <= FFH1;
   FFH3 <= FFH2;
   FFH4 <= FFH3;
   FFH5 <= FFH4;
   FFH6 <= FFH5;
   ORH0 <= FF_OUT_RDY;
   ORH1 <= ORH0;
   ORH2 <= ORH1;
   ORH3 <= ORH2;
   ORH4 <= ORH3;
   ORH5 <= ORH4;
   ORH6 <= ORH5;
   MTCH1 <= MTCH2_OUT_OF_3;
   MTCH2 <= MTCH1;
   MTCH3 <= MTCH2;
   MTCH4 <= MTCH3;
   MTCH5 <= MTCH4;
   MTCH6 <= MTCH5;
   NE1 <= NE3_OUT_OF_3;
   NE2 <= NE1;
   NE3 <= NE2;
   NE4 <= NE3;
   NE5 <= NE4;
   NE6 <= NE5;
   MRST1 <= MRST;
   MRST2 <= MRST1;
   MRST3 <= MRST2;
   PRST1 <= PRST;
   PRST2 <= PRST1;
   PRST3 <= PRST2;
end

// Begining of Data Mux
always @(DATA_IN1 or SEL_BOD)
begin
   if(SEL_BOD)
      DAT_BOD <= 16'hDB0D;
   else
      DAT_BOD <= DATA_IN1;
end

///////////////////////////////////////////////////////////////
//                                                           //
// ENCODER for Golay(24,12) ECC code                         //
//                                                           //
///////////////////////////////////////////////////////////////

ecc_encode ecc_encode_1(.CLK(CLK),.DATA(DAT_BOD[11:0]),.PARITY(ECC_PARITY));

///////////////////////////////////////////////////////////////
//                                                           //
// Majority logic for controls and address                   //
//                                                           //
///////////////////////////////////////////////////////////////
always @(FROM_FIFO1)
begin
   FF_MJ_DCD <= (FROM_FIFO1[15:12] & FROM_FIFO1[31:28]) | (FROM_FIFO1[15:12] & FROM_FIFO1[35:32]) | (FROM_FIFO1[35:32] & FROM_FIFO1[31:28]);
   MTCH2_OUT_OF_3 <= (((FROM_FIFO1[35:32] == 4'hB) && (FROM_FIFO1[31:28] == 4'h0)) || ((FROM_FIFO1[35:32] == 4'hB) && (FROM_FIFO1[15:12] == 4'hD)) || ((FROM_FIFO1[31:28] == 4'h0) && (FROM_FIFO1[15:12] == 4'hD))); 
   NE3_OUT_OF_3 <= (FROM_FIFO1[15:12] != FROM_FIFO1[31:28]) && (FROM_FIFO1[15:12] != FROM_FIFO1[35:32]) && (FROM_FIFO1[31:28] != FROM_FIFO1[35:32]); 
end


// Instansiate the external clock drivers as double data rate output flip flops.

// WCLK in phase with CLK
//OFDDRRSE Ext_Wclk (.Q(FF_WCLK),.C0(CLK),.C1(!CLK),.CE(1'b1),.D0(1'b1),.D1(1'b0),.R(1'b0),.S(1'b0));
//
// WCLK out of phase with CLK
OFDDRRSE Ext_Wclk (.Q(FF_WCLK),.C0(CLK),.C1(!CLK),.CE(1'b1),.D0(1'b0),.D1(1'b1),.R(1'b0),.S(1'b0));

// RCLK in phase with CLK
OFDDRRSE Ext_Rclk (.Q(FF_RCLK),.C0(CLK),.C1(!CLK),.CE(1'b1),.D0(1'b1),.D1(1'b0),.R(1'b0),.S(1'b0));
// RCLK out of phase with CLK
//OFDDRRSE Ext_Rclk (.Q(FF_RCLK),.C0(CLK),.C1(!CLK),.CE(1'b1),.D0(1'b0),.D1(1'b1),.R(1'b0),.S(1'b0));

// SCLK is no longer used
//OFDDRRSE Ext_Sclk (.Q(FF_SCLK),.C0(SER_CLK),.C1(!SER_CLK),.CE(1'b1),.D0(1'b0),.D1(1'b1),.R(1'b0),.S(1'b0));
assign FF_SCLK = 0;   

// OUTPUT REGISTERS
always @(posedge CLK)
begin
   WEN1 <= WEN;
   FF_WEN_B <= !WEN1 && !LOAD1 && !LOAD2 && !LOAD_BOD;
   WLOAD <= LOAD1 || LOAD2;
   FF_MARK  <= MARK;
   CAP_OFF1 <= UPDTOFF1;
   CAP_OFF2 <= UPDTOFF2;
   if(LOAD1)
      TO_FIFO <= {16'h0000,OFFSET[17:16],1'b0,OFFSET[15:8],1'b0,OFFSET[7:0]};
   else if(LOAD2) 
      TO_FIFO <= {16'h0000,OFFSET[35:34],1'b0,OFFSET[33:26],1'b0,OFFSET[25:18]};
   else  if(LOAD_BOD)
      TO_FIFO <= {8'hB0,ECC_PARITY,DATA_IN2}; 
   else 
      TO_FIFO <= {DATA_IN2[15:12],DATA_IN2[15:12],ECC_PARITY,DATA_IN2}; 
end
//always @(posedge CLK)
//begin
//   FF_REN_B <= !REN && !RDOFF;
//   RLOAD <= RDOFF;
//   FF_RT_B  <= !RT;
//end
always @(negedge CLK)
begin
   FF_REN_B <= !REN && !RDOFF && !DRP;
   RLOAD <= RDOFF;
   FF_RT_B  <= !RT;
end

///////////////////////////////////////////////////////////////
//                                                           //
// DECODER for Golay(24,12) ECC code                         //
//                                                           //
///////////////////////////////////////////////////////////////

ecc_decode ecc_decode_FF1(.CLK(CLK),.RCV_DATA(FROM_FIFO1[11:0]),.RCV_PARITY(FROM_FIFO1[27:16]),.GOOD_WORD(GOOD_WORD),
              .DCD_DATA(DCD_DATA),.DCD_PARITY(DCD_PARITY),.BAD_TX(BAD_TX));

always @(posedge CLK or posedge ERR_CNT_RST)
begin
   if(ERR_CNT_RST)
      begin
         UN_COR_ERR_REG <= 32'h00000000;
         COR_ERR_REG <= 32'h00000000;
      end
   else
      if(DCD_DAT_VALID && !GOOD_WORD && BAD_TX)
         begin
            UN_COR_ERR_REG <= UN_COR_ERR_REG + 1;
            COR_ERR_REG <= COR_ERR_REG;
         end
      else if(DCD_DAT_VALID && GOOD_WORD && BAD_TX) 
         begin
            UN_COR_ERR_REG <= UN_COR_ERR_REG;
            COR_ERR_REG <= COR_ERR_REG + 1;
         end
      else 
         begin
            UN_COR_ERR_REG <= UN_COR_ERR_REG;
            COR_ERR_REG <= COR_ERR_REG;
         end
end

always @(posedge CLK)
begin
   if(OE)
      case ({ERCNT,L4,L3,L2,L1_FR})
         `Hi_Full_Off:
            DATA_OUT <= {14'h0000,OFFSET[35:34]};
         `Lo_Full_Off:
            DATA_OUT <= OFFSET[33:18];
         `Hi_Empt_Off:
            DATA_OUT <= {14'h0000,OFFSET[17:16]};
         `Lo_Empt_Off:
            DATA_OUT <= OFFSET[15:0];
         `Hi_Un_Cor_Err_Cnt:
            DATA_OUT <= UN_COR_ERR_REG[31:16];
         `Lo_Un_Cor_Err_Cnt:
            DATA_OUT <= UN_COR_ERR_REG[15:0];
         `Hi_Cor_Err_Cnt:
            DATA_OUT <= COR_ERR_REG[31:16];
         `Lo_Cor_Err_Cnt:
            DATA_OUT <= COR_ERR_REG[15:0];
         default:
            if(ECC_ENA)
               DATA_OUT <= {FFH6,DCD_DATA};
            else
               DATA_OUT <= FROM_FIFO1[15:0];
      endcase
   else
      DATA_OUT <= 16'hZZZZ;
end

always @(posedge CLK)
begin
   if(ECC_ENA)
      begin
         BEG_O_DATA <= (DCD_DATA == 12'hB0D) && NE6 && MTCH6;
         INT_OUT_RDY <= ORH6;
      end
   else
      begin
         BEG_O_DATA <= (FROM_FIFO1[11:0] == 12'hB0D) && NE3_OUT_OF_3 && MTCH2_OUT_OF_3;
         INT_OUT_RDY <= ORH0;
      end
   OUT_RDY <= TEST_MODE ? (INT_OUT_RDY && FF_OUT_RDY) : (INT_OUT_RDY && FF_OUT_RDY && !BEG_O_DATA);
end



/////////////////////////////////////////////////////
//                                                 //
//  FIFO Write related processes                   //
//                                                 //
/////////////////////////////////////////////////////



always @(posedge CLK or posedge FF_RST)
begin: Ext_FF_WR_FSM
   if (FF_RST)
      EXFF_WR_ST <= `FFW_Rst;
   else
      case (EXFF_WR_ST)
         `FFW_Rst:
            EXFF_WR_ST <= `FFW_Rst_Mark;
         `FFW_Rst_Mark:
            EXFF_WR_ST <= `Set_FWFT;
         `Set_FWFT:
            EXFF_WR_ST <= `MRst_St;
         `MRst_St:
            if (MRST3)
               EXFF_WR_ST <= `Hold_FWFT;
            else
               EXFF_WR_ST <= `MRst_St;
         `Hold_FWFT:
            EXFF_WR_ST <= `MRst_Done;
         `MRst_Done:
            if (WFUNCT != `MRst_FF)
               EXFF_WR_ST <= `FFW_Idle;
            else
               EXFF_WR_ST <= `MRst_Done;
         `FFW_Idle:
            if (WFUNCT == `Wrt_FF)
               EXFF_WR_ST <= `Input_Rdy;
            else if (WFUNCT == `Prg_Offsets)
               EXFF_WR_ST <= `W_Valdat2;
            else if (WFUNCT == `MRst_FF)
               EXFF_WR_ST <= `FFW_Rst_Mark;
            else if (WFUNCT == `PRst_FF)
               EXFF_WR_ST <= `PRst_St;
            else if (WFUNCT == `Rst_Err_Cnts)
               EXFF_WR_ST <= `Rst_Err_Cnt_St;
            else
               EXFF_WR_ST <= `FFW_Idle;
         `Input_Rdy:
            if (WFUNCT != `Wrt_FF)
               EXFF_WR_ST <= `FFW_Idle;
            else if (!PAF && TEST_MODE)
               EXFF_WR_ST <= `W_Valdat1;
            else if (!PAF && !TEST_MODE)
               EXFF_WR_ST <= `Enc_BOD;
            else
               EXFF_WR_ST <= `Input_Rdy;
         `Enc_BOD:
            EXFF_WR_ST <= `Load_BOD;
         `Load_BOD:
            EXFF_WR_ST <= `W_Valdat1;
         `W_Valdat1:
            if ((WFUNCT == `Wrt_FF) && VALDAT)
               EXFF_WR_ST <= `Write_FF;
            else if (WFUNCT != `Wrt_FF)
               EXFF_WR_ST <= `FFW_Idle;
            else
               EXFF_WR_ST <= `W_Valdat1;
         `Write_FF:
            if (!IN_RDY)
               EXFF_WR_ST <= `Wrt_Err;
            else if ((WFUNCT == `Wrt_FF) && !VALDAT)
               EXFF_WR_ST <= `W_Valdat1;
            else if (WFUNCT != `Wrt_FF)
               EXFF_WR_ST <= `FFW_Idle;
            else
               EXFF_WR_ST <= `Write_FF;
         `Wrt_Err:
            if (WFUNCT != `Wrt_FF)
               EXFF_WR_ST <= `FFW_Idle;
            else
               EXFF_WR_ST <= `Wrt_Err;
         `W_Valdat2:
            if (VALDAT)
               EXFF_WR_ST <= `Load_Offsets;
            else
               EXFF_WR_ST <= `W_Valdat2;
         `Load_Offsets:
            if(L4) 
               EXFF_WR_ST <= `Wrt_Off_to_1;
            else
               EXFF_WR_ST <= `Load_Offsets;
         `Wrt_Off_to_1:
            EXFF_WR_ST <= `Wrt_Off_to_2;
         `Wrt_Off_to_2:
            EXFF_WR_ST <= `Prg_Done;
         `Prg_Done:
            if (WFUNCT != `Prg_Offsets)
               EXFF_WR_ST <= `FFW_Idle;
            else
               EXFF_WR_ST <= `Prg_Done;
         `PRst_St:
            if (PRST3)
               EXFF_WR_ST <= `PRst_Done;
            else
               EXFF_WR_ST <= `PRst_St;
         `PRst_Done:
            if (WFUNCT != `PRst_FF)
               EXFF_WR_ST <= `FFW_Idle;
            else
               EXFF_WR_ST <= `PRst_Done;
         `Rst_Err_Cnt_St:
            if (WFUNCT != `Rst_Err_Cnts)
               EXFF_WR_ST <= `FFW_Idle;
            else
               EXFF_WR_ST <= `Rst_Err_Cnt_St;
         default:
            EXFF_WR_ST <= `FFW_Idle;
      endcase
end

always @ (EXFF_WR_ST)
begin: Ext_FF_WR_BOD
   case (EXFF_WR_ST)
      `Enc_BOD:
         begin
            SEL_BOD <= 1;
            LOAD_BOD  <= 0;
         end
      `Load_BOD:
         begin
            SEL_BOD <= 0;
            LOAD_BOD  <= 1;
         end
      default:
         begin
            SEL_BOD <= 0;
            LOAD_BOD  <= 0;
         end
   endcase
end

always @ (EXFF_WR_ST)
begin: Ext_FF_WR_OUTPUTS_0
   case (EXFF_WR_ST)
      `W_Valdat1:
         begin
            WEN <= 0;
            WRT_ERR  <= 0;
            WHOLD     <= 0;
         end
      `Write_FF:
         begin
            WEN <= 1;
            WRT_ERR  <= 0;
            WHOLD     <= 0;
         end
      `Wrt_Err:
         begin
            WEN <= 0;
            WRT_ERR  <= 1;
            WHOLD     <= 1;
         end
      default:
         begin
            WEN <= 0;
            WRT_ERR  <= 0;
            WHOLD    <= 1;
         end
   endcase
end

always @ (EXFF_WR_ST)
begin: Ext_FF_WR_OUTPUTS_1
   case (EXFF_WR_ST)
      `Load_Offsets:
         begin
            L1_TO <= 1;
            CLRL_TO <= 0;
            LOAD1 <= 0;
            LOAD2 <= 0;
         end
      `Wrt_Off_to_1:
         begin
            L1_TO <= 0;
            CLRL_TO <= 1;
            LOAD1 <= 1;
            LOAD2 <= 0;
         end
      `Wrt_Off_to_2:
         begin
            L1_TO <= 0;
            CLRL_TO <= 0;
            LOAD1 <= 0;
            LOAD2 <= 1;
         end
      default:
         begin
            L1_TO <= 0;
            CLRL_TO <= 0;
            LOAD1 <= 0;
            LOAD2 <= 0;
         end
   endcase
end

always @ (EXFF_WR_ST)
begin: Ext_FF_WR_OUTPUTS_2
   case (EXFF_WR_ST)
      `Prg_Done:
         begin
            PRGDONE <= 1;
            MRSTDONE <= 0;
            PRSTDONE <= 0;
         end
      `MRst_Done:
         begin
            PRGDONE <= 0;
            MRSTDONE <= 1;
            PRSTDONE <= 0;
         end
      `PRst_Done:
         begin
            PRGDONE <= 0;
            MRSTDONE <= 0;
            PRSTDONE <= 1;
         end
      default:
         begin
            PRGDONE <= 0;
            MRSTDONE <= 0;
            PRSTDONE <= 0;
         end
   endcase
end

always @ (EXFF_WR_ST)
begin: Ext_FF_WR_OUTPUTS_3
   case (EXFF_WR_ST)
      `FFW_Rst_Mark:
         begin
            PU_RSM <= 1;
            FWFT <= 0;
            TRESET <= 1;
            MRST <= 0;
            PRST <= 0;
            RST_ERR_CNT <= 0;
         end
      `Set_FWFT:
         begin
            PU_RSM <= 0;
            FWFT <= 1;
            TRESET <= 1;
            MRST <= 0;
            PRST <= 0;
            RST_ERR_CNT <= 0;
         end
      `MRst_St:
         begin
            PU_RSM <= 0;
            FWFT <= 1;
            TRESET <= 1;
            MRST <= 1;
            PRST <= 0;
            RST_ERR_CNT <= 0;
         end
      `Hold_FWFT:
         begin
            PU_RSM <= 0;
            FWFT <= 1;
            TRESET <= 1;
            MRST <= 0;
            PRST <= 0;
            RST_ERR_CNT <= 0;
         end
      `PRst_St:
         begin
            PU_RSM <= 0;
            FWFT <= 0;
            TRESET <= 0;
            MRST <= 0;
            PRST <= 1;
            RST_ERR_CNT <= 0;
         end
      `Rst_Err_Cnt_St:
         begin
            PU_RSM <= 0;
            FWFT <= 0;
            TRESET <= 0;
            MRST <= 0;
            PRST <= 0;
            RST_ERR_CNT <= 1;
         end
      default:
         begin
            PU_RSM <= 0;
            FWFT <= 0;
            TRESET <= 0;
            MRST <= 0;
            PRST <= 0;
            RST_ERR_CNT <= 0;
         end
   endcase
end

always @(posedge CLK or posedge CLRL)
begin
   if (CLRL)
      begin
         L2 <= 0;
         L3 <= 0;
         L4 <= 0;
      end
   else
      begin
         L2 <= L1_TO || L1_FR;
         L3 <= L2;
         L4 <= L3;
      end
end

always @ (posedge CLK or posedge POW_ON_RST)
begin: Offset_Reg
   if (POW_ON_RST)
      OFFSET <= 0;
   else 
      case ({1'b0,L4,L3,L2,L1_TO})
         4'd0:
            if (CAP_OFF1)
               OFFSET <= {OFFSET[35:18],FROM_FIFO1[19:18],FROM_FIFO1[16:9],FROM_FIFO1[7:0]};
            else if (CAP_OFF2)
               OFFSET <= {FROM_FIFO1[19:18],FROM_FIFO1[16:9],FROM_FIFO1[7:0],OFFSET[17:0]};
            else
               OFFSET <= OFFSET;
         `Hi_Full_Off:
            OFFSET[35:34] <= DATA_IN1[1:0];
         `Lo_Full_Off:
            OFFSET[33:18] <= DATA_IN1;
         `Hi_Empt_Off:
            OFFSET[17:16] <= DATA_IN1[1:0];
         `Lo_Empt_Off:
            OFFSET[15:0] <= DATA_IN1;
         default:
            OFFSET <= OFFSET;
      endcase
end

/////////////////////////////////////////////////////
//                                                 //
//  FIFO Read related processes                    //
//                                                 //
/////////////////////////////////////////////////////

always @(posedge CLK or posedge POW_ON_RST)
begin: Ext_FF_RD_FSM
   if (POW_ON_RST)
      EXFF_RD_ST <= `FFR_Idle;
   else
      case (EXFF_RD_ST)
         `FFR_Idle:
            if (INT_OUT_RDY && BEG_O_DATA)
               EXFF_RD_ST <= `Flush_BOD;
            else
               case (RFUNCT)
                  `Rd_FF:
                     EXFF_RD_ST <= `Pause;
                  `RT_FF:
                     if(MARK)
                        EXFF_RD_ST <= `ReTrans;
                     else
                        EXFF_RD_ST <= `ReTrans_Err;
                  `SET_MK_FF:
                     if(PAE)
                        EXFF_RD_ST <= `FF_MK_Err;
                     else 
                        EXFF_RD_ST <= `RST_Mark;
                  `RST_MK_FF:
                     EXFF_RD_ST <= `RST_Mark;
                  `Rdbk_Offsets:
                     EXFF_RD_ST <= `Rd_Off;
                  `Rd_Err_Cnts:
                     EXFF_RD_ST <= `W4Read2;
                  `Flush_FF:
                     if(FF_OUT_RDY)
                        EXFF_RD_ST <= `Drop_Wrd;
                     else
                        EXFF_RD_ST <= `Flush_Done;
                  default:
                     EXFF_RD_ST <= `FFR_Idle;
               endcase
         `RST_Mark:
            if (RFUNCT == `SET_MK_FF)
               EXFF_RD_ST <= `Set_Mark;
            else if (RFUNCT != `RST_MK_FF)
               EXFF_RD_ST <= `FFR_Idle;
            else
               EXFF_RD_ST <= `RST_Mark;
         `Set_Mark:
            if (RFUNCT != `SET_MK_FF)
               EXFF_RD_ST <= `FFR_Idle;
            else
               EXFF_RD_ST <= `Set_Mark;
         `Pause: 
            if (OUT_RDY)
               EXFF_RD_ST <= `Wait_for_Read;
            else if (RD_TMOUT)
               EXFF_RD_ST <= `FF_MT_Err;
            else
               EXFF_RD_ST <= `Pause;
         `Wait_for_Read:
            if (READ)
               EXFF_RD_ST <= `Read_FF;
            else if ((RFUNCT != `Rd_FF) && (RFUNCT != `RT_FF))
               EXFF_RD_ST <= `FFR_Idle;
            else
               EXFF_RD_ST <= `Wait_for_Read;
         `Read_FF:
            if (!OUT_RDY)
               EXFF_RD_ST <= `FF_Rd_Err;
            else if ((RFUNCT != `Rd_FF) && (RFUNCT != `RT_FF))
               EXFF_RD_ST <= `FFR_Idle;
            else if (!READ)
               EXFF_RD_ST <= `Wait_for_Read;
            else
               EXFF_RD_ST <= `Read_FF;
         `ReTrans:
               EXFF_RD_ST <= `Pause;
         `ReTrans_Err:
            if (RFUNCT != `RT_FF)
               EXFF_RD_ST <= `FFR_Idle;
            else
               EXFF_RD_ST <= `ReTrans_Err;
         `FF_MT_Err:
            if ((RFUNCT != `Rd_FF) && (RFUNCT != `RT_FF))
               EXFF_RD_ST <= `FFR_Idle;
            else
               EXFF_RD_ST <= `FF_MT_Err;
         `FF_MK_Err:
            if (RFUNCT != `SET_MK_FF)
               EXFF_RD_ST <= `FFR_Idle;
            else
               EXFF_RD_ST <= `FF_MK_Err;
         `FF_Rd_Err:
            if ((RFUNCT != `Rd_FF) && (RFUNCT != `RT_FF))
               EXFF_RD_ST <= `FFR_Idle;
            else
               EXFF_RD_ST <= `FF_Rd_Err;
         `Rd_Off:
            EXFF_RD_ST <= `Pause_Off1;
         `Pause_Off1:
            EXFF_RD_ST <= `Rd_Off_Upd;
         `Rd_Off_Upd:
            EXFF_RD_ST <= `Pause_Off2;
         `Pause_Off2:
            EXFF_RD_ST <= `Update_Off;
         `Update_Off:
            EXFF_RD_ST <= `W4Capture;
         `W4Capture:
            if (CAP_OFF2)
               EXFF_RD_ST <= `W4Read;
            else
               EXFF_RD_ST <= `W4Capture;
         `W4Read:
            if (READ)
               EXFF_RD_ST <= `Send_Offsets;
            else if (RFUNCT != `Rdbk_Offsets)
               EXFF_RD_ST <= `FFR_Idle;
            else
               EXFF_RD_ST <= `W4Read;
         `Send_Offsets:
            if(L4) 
               EXFF_RD_ST <= `Rbk_Done;
            else
               EXFF_RD_ST <= `Send_Offsets;
         `Rbk_Done:
            if ((RFUNCT != `Rdbk_Offsets) && (RFUNCT != `Rd_Err_Cnts))
               EXFF_RD_ST <= `FFR_Idle;
            else
               EXFF_RD_ST <= `Rbk_Done;
         `W4Read2:
            if (READ)
               EXFF_RD_ST <= `Send_Err_Cnts;
            else if (RFUNCT != `Rd_Err_Cnts)
               EXFF_RD_ST <= `FFR_Idle;
            else
               EXFF_RD_ST <= `W4Read2;
         `Send_Err_Cnts:
            if(L4) 
               EXFF_RD_ST <= `Rbk_Done;
            else
               EXFF_RD_ST <= `Send_Err_Cnts;
         `Flush_BOD:
            EXFF_RD_ST <= `W4Vldt1;
         `W4Vldt1:
            if(DRP_DAT_VALID) 
               EXFF_RD_ST <= `FFR_Idle;
            else
               EXFF_RD_ST <= `W4Vldt1;
         `Drop_Wrd:
            EXFF_RD_ST <= `W4Vldt2;
         `W4Vldt2:
            if(DRP_DAT_VALID)
               if(!INT_OUT_RDY || BEG_O_DATA) 
                  EXFF_RD_ST <= `Flush_Done;
               else 
                  EXFF_RD_ST <= `Drop_Wrd;
            else
               EXFF_RD_ST <= `W4Vldt2;
         `Flush_Done:
            if(RFUNCT != `Flush_FF) 
               EXFF_RD_ST <= `FFR_Idle;
            else
               EXFF_RD_ST <= `Flush_Done;
         default:
            EXFF_RD_ST <= `FFR_Idle;
      endcase
end



always @(posedge CLK or posedge POW_ON_RST)
begin: MARK_REG
   if(POW_ON_RST)
      MARK <= 0;
   else
      if (STM)
         MARK <= 1;
      else if (RSM || PU_RSM)
         MARK <= 0;
      else
         MARK <= MARK;
end

always @ (EXFF_RD_ST)
begin: Ext_FF_RD_OUTPUTS_0
   case (EXFF_RD_ST)
      `ReTrans_Err:
         begin
            RD_ERR <= 0;
            MT_ERR <= 0;
            RT_ERR <= 1;
            MK_ERR <= 0;
         end
      `FF_Rd_Err:
         begin
            RD_ERR <= 1;
            MT_ERR <= 0;
            RT_ERR <= 0;
            MK_ERR <= 0;
         end
      `FF_MT_Err:
         begin
            RD_ERR <= 0;
            MT_ERR <= 1;
            RT_ERR <= 0;
            MK_ERR <= 0;
         end
      `FF_MK_Err:
         begin
            RD_ERR <= 0;
            MT_ERR <= 0;
            RT_ERR <= 0;
            MK_ERR <= 1;
         end
      default:
         begin
            RD_ERR <= 0;
            MT_ERR <= 0;
            RT_ERR <= 0;
            MK_ERR <= 0;
         end
   endcase
end

always @ (EXFF_RD_ST)
begin: Ext_FF_RD_OUTPUTS_1
   case (EXFF_RD_ST)
      `RST_Mark:
         begin
            RSM <= 1;
            STM <= 0;
         end
      `Set_Mark:
         begin
            RSM <= 0;
            STM <= 1;
         end
      default:
         begin
            RSM <= 0;
            STM <= 0;
         end
   endcase
end

always @ (EXFF_RD_ST)
begin: Ext_FF_RD_OUTPUTS_3
   case (EXFF_RD_ST)
      `Send_Offsets:
         begin
            L1_FR <= 1;
            SDV <= 1;
            CLRL_FR <= 0;
            RBKDONE <= 0;
            ERCNT <= 0;
         end
      `Send_Err_Cnts:
         begin
            L1_FR <= 1;
            SDV <= 1;
            CLRL_FR <= 0;
            RBKDONE <= 0;
            ERCNT <= 1;
         end
      `Rbk_Done:
         begin
            L1_FR <= 0;
            SDV <= 0;
            CLRL_FR <= 1;
            RBKDONE <= 1;
            ERCNT <= 0;
         end
      default:
         begin
            L1_FR <= 0;
            SDV <= 0;
            CLRL_FR <= 0;
            RBKDONE <= 0;
            ERCNT <= 0;
         end
   endcase
end

always @ (EXFF_RD_ST)
begin: Ext_FF_RD_OUTPUTS_4
   case (EXFF_RD_ST)
      `Rd_Off:
         begin
            RDOFF <= 1;
            UPDTOFF1 <= 0;
            UPDTOFF2 <= 0;
         end
      `Rd_Off_Upd:
         begin
            RDOFF <= 1;
            UPDTOFF1 <= 1;
            UPDTOFF2 <= 0;
         end
      `Update_Off:
         begin
            RDOFF <= 0;
            UPDTOFF1 <= 0;
            UPDTOFF2 <= 1;
         end
      default:
         begin
            RDOFF <= 0;
            UPDTOFF1 <= 0;
            UPDTOFF2 <= 0;
         end
   endcase
end

always @(posedge CLK)
begin
   RDE1 <= RD_ERR;
   RDE2 <= RDE1;
   RDE3 <= RDE2;
   RDE4 <= RDE3;
   RDE5 <= RDE4;
   RDE6 <= RDE5;
end
always @(posedge CLK)
begin
   ODV1 <= REN;
   ODV2 <= ODV1;
   ODV3 <= ODV2;
   ODV4 <= ODV3;
   ODV5 <= ODV4;
   ODV6 <= ODV5;
   ODV7 <= ODV6;
//
   FDV1 <= DRP;
   FDV2 <= FDV1;
   FDV3 <= FDV2;
   FDV4 <= FDV3;
   FDV5 <= FDV4;
   FDV6 <= FDV5;
   FDV7 <= FDV6;
//
   DCD_DAT_VALID <= ODV6 || FDV6;
   if(ECC_ENA)
      begin
         OUT_DAT_VALID <= (ODV7 && !RDE6) || SDV;
         DRP_DAT_VALID <= FDV7;
      end
   else
      begin
         OUT_DAT_VALID <= (ODV1 && !RD_ERR) || SDV;
         DRP_DAT_VALID <= FDV1;
      end
end

always @ (EXFF_RD_ST)
begin: Ext_FF_RD_OUTPUTS_5
   case (EXFF_RD_ST)
      `Pause: 
         ENATMR <= 1;
      default:
         ENATMR <= 0;
   endcase
end

always @ (EXFF_RD_ST)
begin: Ext_FF_RD_OUTPUTS_6
   case (EXFF_RD_ST)
      `Read_FF:
         begin 
            REN <= 1;
            DRP <= 0;
         end
      `Drop_Wrd,`Flush_BOD:
         begin 
            REN <= 0;
            DRP <= 1;
         end
      default:
         begin 
            REN <= 0;
            DRP <= 0;
         end
   endcase
end

always @ (EXFF_RD_ST)
begin: Ext_FF_RD_OUTPUTS_7
   case (EXFF_RD_ST)
      `Wait_for_Read,`Read_FF:
         RHOLD <= 0;
      default:
         RHOLD <= 1;
   endcase
end

always @ (EXFF_RD_ST)
begin: Ext_FF_RD_OUTPUTS_8
   case (EXFF_RD_ST)
      `ReTrans: 
         RT <= 1;
      default:
         RT <= 0;
   endcase
end

always @ (EXFF_RD_ST)
begin: Ext_FF_RD_OUTPUTS_9
   case (EXFF_RD_ST)
      `Flush_Done: 
         FLSHD <= 1;
      default:
         FLSHD <= 0;
   endcase
end

always @(posedge CLK or posedge POW_ON_RST)
begin
   if(POW_ON_RST)
      RD_TMR <= 12'h000;
   else
      if(ENATMR)
         RD_TMR <= RD_TMR + 1;
      else
         RD_TMR <= 12'h000;
end

endmodule
